## yoshimi 2.2.0

=== src/CMakeLists.txt ===
#
#   CMakeLists.txt
#
#   Copyright 2009-2011, Alan Calvert
#   Copyright 2014-2021, Will Godfrey & others
#
#   This file is part of yoshimi, which is free software: you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation, either
#   version 2 of the License, or (at your option) any later version.
#
#   yoshimi is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.

project (Yoshimi)
cmake_minimum_required (VERSION 3.0)
cmake_policy (VERSION 3.0)
cmake_policy (SET CMP0004 NEW)
if (POLICY CMP0046)
    cmake_policy (SET CMP0046 NEW)
endif () # opengl version
if (POLICY CMP0072)
    cmake_policy (SET CMP0072 NEW)
endif ()

#set(CMAKE_CXX_COMPILER "clang++")

set (CMAKE_CXX_STANDARD 14) # we seem to need both for
add_definitions(-std=gnu++14) # various versions of cmake

add_definitions(-Wall)

# vvv
#add_definitions(-Wpedantic) # full ISO spec
#add_definitions(-Werror) # warnings as errors
#add_definitions(-Wfatal-errors) # stop on first
#add_definitions(-Werror=format-security)
#add_definitions(-Wextra)
#add_definitions(-Wno-vla) # Nothing wrong with variable length arrays
#add_definitions(-Wno-deprecated)
# ^^^ comment these out on release pushes

set (YOSHIMI_VERSION "2.2.0")

add_definitions (-DMIN_CONFIG_MAJOR=2)
add_definitions (-DMIN_CONFIG_MINOR=0)

file (WRITE version.txt "${YOSHIMI_VERSION}")

set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_USE_RELATIVE_PATHS OFF)
    # relative paths break some scripts(?)
set (CMAKE_SKIP_RULE_DEPENDENCY OFF)
    # Rebuild objects if rules have changed, even if source hasn't.

message (STATUS "Building Yoshimi version ${YOSHIMI_VERSION} for ${CMAKE_SYSTEM_NAME}")

include (CheckCSourceCompiles)
include(GNUInstallDirs)

mark_as_advanced (EXECUTABLE_OUTPUT_PATH)
mark_as_advanced (LIBRARY_OUTPUT_PATH)
mark_as_advanced (CMAKE_BUILD_TYPE)
mark_as_advanced (CMAKE_INSTALL_PREFIX)

# Check for jack session availability
check_c_source_compiles (
    "#include <jack/session.h>
    int main(int argc, char **argv)
    {
        jack_session_event_type_t x = JackSessionSave;
        return 0;
    }" HasJackSession
)

if (HasJackSession)
    option (JackSessionSupport "Include Jack Session Support" ON)
else()
    set (JackSessionSupport OFF)
endif ()

option (BuildFor0ld_X86 "Build for legacy x86 system" OFF)

option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
option (BuildForRasPi4 "Build for ARM Cortex A9 system" OFF)
option (BuildForThisCPU "Build for presently running system" OFF)
option (BuildForDebug "Debug build without optimisation. Enable gdb debugging support" OFF)

option (BuildWithFLTK "Build with FLTK GUI" ON)

#option to build lv2 plugin
option (LV2Plugin "Build yoshimi lv2 plugin interface" ON)

# developer info
option (ShowNoteOnTimes "Report Note-On Times" OFF)
option (ReportNotes "Report Notes On/Off" OFF)


set (BuildOptions_X86
    "-msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
    CACHE STRING "basic X86 compiler options"
)

set (BuildOptions_X86_64AMD
    "-march=athlon64 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
    CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_X86_64Core2
    "-march=core2 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
    CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_RasPi4
    "-march=native -mfloat-abi=hard -mfpu=vfp -mcpu=cortex-a72 -mtune=cortex-a72 -pipe -mvectorize-with-neon-quad -funsafe-loop-optimizations"
    CACHE STRING "Raspberry Pi V4 compiler options"
)

set (BuildOptionsThisCPU
    "-march=native -mtune=native -Wall"
    CACHE STRING "Current CPU compiler options"
)

set (BuildOptionsBasic
    "-ffast-math -fomit-frame-pointer"
    CACHE STRING "basic compilier options"
)

set (BuildOptionsDebug
    "-O0 -g3 -ggdb -Wpointer-arith -Wpedantic -Wextra" CACHE STRING "Compile without optimisation and with debug information")
set (BuildOptionsRelease
    "-O3" CACHE STRING "Compile with optimisation for Release builds")

if (BuildWithFLTK)
    add_definitions (-DGUI_FLTK)
endif ()

find_package (PkgConfig REQUIRED)

find_package(Threads REQUIRED)

check_c_source_compiles (
    "#include <argp.h>
    #include <stdlib.h>
    int main () {
        int argc=1;
        char *argv[]={\"test\"};
        argp_parse(0,argc,argv,0,0,0);
        return 0;
    }" LIBC_HAS_ARGP
)

if (NOT LIBC_HAS_ARGP)
    message(STATUS "libc does not have argp")
    find_library (ARGP_LIB argp REQUIRED)
endif ()

# libz
find_package(ZLIB REQUIRED)

# fftw3f
pkg_check_modules (FFTW3F REQUIRED fftw3f>=0.22)

# mxml
pkg_check_modules (MXML REQUIRED mxml>=2.5)

# Alsa
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
    pkg_check_modules (ALSA REQUIRED alsa>=1.0.17)
    add_definitions(-DHAVE_ALSA)
    FIND_LIBRARY(LIBDL_LINUX NAMES dl)
else()

endif ()

# Jack
pkg_check_modules (JACK REQUIRED jack>=0.115.6)

# fontconfig
pkg_check_modules (FONTCONFIG REQUIRED fontconfig>=0.22)
mark_as_advanced(FONTCONFIG_LIBRARIES)


if (BuildWithFLTK)
# libcairo
    pkg_check_modules (LIBCAIRO REQUIRED cairo)

# fltk
    find_package (FLTK REQUIRED)
    mark_as_advanced (FLTK_DIR)
    mark_as_advanced (FLTK_FLUID_EXECUTABLE)
    mark_as_advanced (FLTK_MATH_LIBRARY)
endif ()


# libncurses / libcursesw
set(CURSES_NEED_NCURSES TRUE)
find_package (Curses REQUIRED)

find_path(Readline_ROOT_DIR
    NAMES include/readline/readline.h
)

find_path(Readline_INCLUDE_DIR
    NAMES readline/readline.h
    HINTS ${Readline_ROOT_DIR}/include
)

find_library(Readline_LIBRARY
    NAMES readline
    HINTS ${Readline_ROOT_DIR}/lib
)

#find_package(PkgConfig REQUIRED)
if (Readline_INCLUDE_DIR AND Readline_LIBRARY AND CURSES_LIBRARY)
    set(READLINE_FOUND TRUE)
else()
    FIND_LIBRARY(Readline_LIBRARY NAMES readline)
    include(FindPackageHandleStandardArgs)
    FIND_PACKAGE_HANDLE_STANDARD_ARGS(Readline DEFAULT_MSG Readline_INCLUDE_DIR Readline_LIBRARY )
    MARK_AS_ADVANCED(Readline_INCLUDE_DIR Readline_LIBRARY)
endif ()

mark_as_advanced(
    Readline_ROOT_DIR
    Readline_INCLUDE_DIR
    Readline_LIBRARY
)

if (READLINE_FOUND)
    message (STATUS "Readline library found" )
else()
    message( FATAL_ERROR "Readline library not found! Please install development components (libreadline-dev)" )
endif ()

# set platform specific compiler flags
if (BuildFor0ld_X86)
    set (OurCxxFlags ${BuildOptions_X86})
elseif (BuildForAMD_X86_64)
    set (OurCxxFlags ${BuildOptions_X86_64AMD})
elseif (BuildForCore2_X86_64)
    set (OurCxxFlags ${BuildOptions_X86_64Core2})
elseif (BuildForNEON)
    set (OurCxxFlags ${BuildOptions_NEON})
elseif (BuildForThisCPU)
    set (OurCxxFlags ${BuildOptionsThisCPU})
else()
    set (OurCxxFlags ${BuildOptionsBasic})
endif ()
set (CMAKE_CXX_FLAGS "${OurCxxFlags} ${CMAKE_CXX_FLAGS}")

if (BuildForDebug)
    set (CMAKE_BUILD_TYPE "Debug")
    set (CMAKE_CXX_FLAGS_DEBUG ${BuildOptionsDebug})
    message (STATUS "DEBUG Build, flags: ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG}")
else()
    set (CMAKE_BUILD_TYPE "Release")
    set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsRelease})
    message (STATUS "RELEASE Build, flags: ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELEASE}")
endif ()

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/../desktop/yoshimi.desktop.in"
    "${CMAKE_CURRENT_BINARY_DIR}/yoshimi.desktop"
    IMMEDIATE @ONLY)

set (DSP_sources
    DSP/AnalogFilter.cpp  DSP/Filter.cpp  DSP/FormantFilter.cpp
    DSP/SVFilter.cpp  DSP/Unison.cpp
)

set (Effects_sources
    Effects/Alienwah.cpp  Effects/Chorus.cpp  Effects/Echo.cpp
    Effects/EffectLFO.cpp  Effects/EffectMgr.cpp  Effects/Effect.cpp
    Effects/Phaser.cpp  Effects/Reverb.cpp  Effects/EQ.cpp
    Effects/Distorsion.cpp  Effects/DynamicFilter.cpp
)

set (Misc_sources
    Misc/CmdOptions.cpp  Misc/Config.cpp  Misc/SynthEngine.cpp  Misc/Bank.cpp
    Misc/BuildScheduler.cpp Misc/Microtonal.cpp   Misc/Part.cpp Misc/Splash.cpp
    Misc/WavFile.cpp Misc/XMLwrapper.cpp
)

set (Interface_Sources
    Interface/InterChange.cpp
    Interface/Data2Text.cpp
    Interface/Text2Data.cpp
    Interface/MidiLearn.cpp
    Interface/MidiDecode.cpp
    Interface/RingBuffer.h
    Interface/TextLists.h
)

set (CLI_Sources
    CLI/CmdInterface.cpp
    #CLI/ConfigCLI.cpp
    CLI/CmdInterpreter.cpp
)

set (Params_sources
    Params/ADnoteParameters.cpp  Params/EnvelopeParams.cpp
    Params/FilterParams.cpp  Params/LFOParams.cpp
    Params/SUBnoteParameters.cpp  Params/PADnoteParameters.cpp
    Params/Controller.cpp  Params/Presets.cpp
    Params/PresetsStore.cpp  Params/UnifiedPresets.cpp
    Params/OscilParameters.cpp
)

set (Synth_sources
    Synth/ADnote.cpp  Synth/Envelope.cpp  Synth/LFO.cpp  Synth/OscilGen.cpp
    Synth/SUBnote.cpp  Synth/Resonance.cpp  Synth/PADnote.cpp
)

set (MusicIO_sources
    MusicIO/MusicClient.cpp  MusicIO/MusicIO.cpp  MusicIO/JackEngine.cpp
    MusicIO/AlsaEngine.cpp
)

if (BuildWithFLTK)
    set (FltkUI_names
        "PresetsUI" "EnvelopeUI"
        "LFOUI" "FilterUI" "VirKeyboardUI"
        "ConfigUI" "SUBnoteUI" "ResonanceUI"
        "OscilGenUI" "ADnoteUI" "PADnoteUI"
        "EffUI" "BankUI" "PartUI"
        "MicrotonalUI" "MasterUI" "MasterMiscUI"
        "ParametersUI" "ConsoleUI" "VectorUI"
        "MidiLearnUI"
    )

# workaround fltk_wrap_ui breakage
    set (FltkUI_sources)
    set (FltkUI_headers)
    foreach(basename ${FltkUI_names})
        set (fluidfile "${CMAKE_CURRENT_SOURCE_DIR}/UI/${basename}.fl")
        set (sourcefile "${basename}.cpp")
        set (headerfile "${basename}.h")
        add_custom_command(
            OUTPUT ${sourcefile}
            COMMAND ${FLTK_FLUID_EXECUTABLE} ARGS -c -o .cpp ${fluidfile}
            DEPENDS ${fluidfile}
        )
        set (FltkUI_sources ${FltkUI_sources} "${sourcefile}")
        set (FltkUI_headers ${FltkUI_headers} "${headerfile}")
    endforeach(basename ${FltkUI_names})

    set (FltkUI_sources
        ${FltkUI_sources}
        UI/DynamicTooltip.cpp
        UI/WidgetPDial.cpp
        UI/WidgetCheckButton.cpp
        UI/WidgetSpinner.cpp
        UI/WidgetMWSlider.cpp
        UI/YoshiWin.cpp
        UI/MiscGui.cpp
    )
    set (YOSHI_INCLUDES ${FLTK_INCLUDE_DIR})
endif ()

add_definitions (
    -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
    -D'BASE_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}"'
    -DYOSHI_FIFO_DIR="${FifoDirectory}"
)

add_definitions (-DYOSHIMI="yoshimi")

if (ShowNoteOnTimes)
    add_definitions (-DREPORT_NOTEON)
endif ()

if (ReportNotes)
    add_definitions (-DREPORT_NOTES_ON_OFF)
endif ()

if (JackSessionSupport)
    message(STATUS "With jack session support")
    add_definitions(-DJACK_SESSION)
else()
    message(STATUS "Without jack session support")
endif ()

# Check for jack latency API >= 0.120.1
check_c_source_compiles (
    "#include <jack/jack.h>
    int main(int argc, char **argv)
    {
        if (jack_set_latency_callback)
            return 0;
        else
            return 1;
    }" HasJackLatency
)

if (HasJackLatency)
    add_definitions(-DJACK_LATENCY)
endif ()

set (ProgSources
    ${Interface_Sources}
    ${CLI_Sources}
    ${Misc_sources}
    ${Params_sources}
    ${Synth_sources}
    ${DSP_sources}
    ${Effects_sources}
    ${MusicIO_sources}
    ${FltkUI_sources}
)

include_directories (AFTER
    ${MXML_INCLUDE_DIRS}
    ${ALSA_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${FONTCONFIG_INCLUDE_DIRS}
    ${FLTK_INCLUDE_DIR}
    ${FFTW3F_INCLUDE_DIRS}
    ${LIBCAIRO_INCLUDE_DIRS}
    ${Readline_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIRS}
)

set(ExternLibraries

=== src/LV2_Plugin/CMakeLists.txt ===
#
#   CMakeLists.txt (LV2)
#
#   Copyright 2014, Andrew Deryabin <andrewderyabin@gmail.com>
#   Copyright 2018-2021, Will Godfrey & others
#
#   This file is part of yoshimi, which is free software: you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation, either
#   version 2 of the License, or (at your option) any later version.
#
#   yoshimi is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.

file (GLOB yoshimi_lv2_plugin_files
        YoshimiLV2Plugin.cpp
        YoshimiLV2Plugin.h
        lv2extui.h
        lv2extprg.h)
file (GLOB yoshimi_dsp_files
    ../DSP/AnalogFilter.cpp  ../DSP/Filter.cpp  ../DSP/FormantFilter.cpp
    ../DSP/SVFilter.cpp  ../DSP/Unison.cpp
    ../DSP/FFTwrapper.h  ../DSP/AnalogFilter.h  ../DSP/FormantFilter.h
    ../DSP/SVFilter.h  ../DSP/Filter.h  ../DSP/Unison.h)
file (GLOB yoshimi_effects_files
    ../Effects/Alienwah.cpp  ../Effects/Chorus.cpp  ../Effects/Echo.cpp
    ../Effects/EffectLFO.cpp  ../Effects/EffectMgr.cpp  ../Effects/Effect.cpp
    ../Effects/Phaser.cpp  ../Effects/Reverb.cpp  ../Effects/EQ.cpp
    ../Effects/Distorsion.cpp  ../Effects/DynamicFilter.cpp
    ../Effects/Alienwah.h  ../Effects/Chorus.h  ../Effects/Echo.h
    ../Effects/EffectLFO.h  ../Effects/EffectMgr.h  ../Effects/Effect.h
    ../Effects/Phaser.h  ../Effects/Reverb.h  ../Effects/EQ.h
    ../Effects/Distorsion.h  ../Effects/DynamicFilter.h)
file (GLOB yoshimi_misc_files
    ../Misc/Config.cpp ../Misc/Config.h ../Misc/ConfBuild.h
    ../Misc/SynthEngine.cpp  ../Misc/Bank.cpp  ../Misc/Microtonal.cpp
    ../Misc/Part.cpp  ../Misc/XMLwrapper.cpp  ../Misc/WavFile.cpp
    ../Misc/SynthEngine.h  ../Misc/Bank.h  ../Misc/Microtonal.h
    ../Misc/Part.h  ../Misc/XMLwrapper.h  ../Misc/WavFile.h
    ../Misc/Alloc.h ../Misc/BuildScheduler.cpp ../Misc/BuildScheduler.h
    ../Misc/TestInvoker.h ../Misc/TestSequence.h
    ../Misc/WaveShapeSamples.h)
file (GLOB yoshimi_interface_files
    ../Interface/MidiDecode.cpp ../Interface/MidiDecode.h
    ../Interface/InterChange.cpp ../Interface/InterChange.h
    ../Interface/Data2Text.cpp ../Interface/Data2text.h
    ../Interface/Text2Data.cpp ../Interface/Text2Data.h
    ../Interface/RingBuffer.h
    ../Interface/MidiLearn.cpp ../Interface/MidiLearn.h
    ../UI/MiscGui.cpp ../UI/MiscGui.h)
file (GLOB yoshimi_params_files
    ../Params/ADnoteParameters.cpp  ../Params/EnvelopeParams.cpp
    ../Params/FilterParams.cpp  ../Params/LFOParams.cpp
    ../Params/SUBnoteParameters.cpp  ../Params/PADnoteParameters.cpp
    ../Params/Controller.cpp  ../Params/Presets.cpp ../Params/PresetsStore.cpp
    ../Params/ADnoteParameters.h  ../Params/EnvelopeParams.h
    ../Params/FilterParams.h  ../Params/LFOParams.h
    ../Params/SUBnoteParameters.h
    ../Params/PADnoteParameters.h ../Params/PADStatus.h ../Params/RandomWalk.h
    ../Params/OscilParameters.cpp ../Params/OscilParameters.h
    ../Params/Controller.h  ../Params/Presets.h ../Params/PresetsStore.h)
file (GLOB yoshimi_synth_files
    ../Synth/ADnote.cpp  ../Synth/Envelope.cpp  ../Synth/LFO.cpp  ../Synth/OscilGen.cpp
    ../Synth/SUBnote.cpp  ../Synth/Resonance.cpp  ../Synth/PADnote.cpp
    ../Synth/ADnote.h  ../Synth/Envelope.h  ../Synth/LFO.h  ../Synth/OscilGen.h
    ../Synth/SUBnote.h  ../Synth/Resonance.h  ../Synth/PADnote.h
    ../Synth/WaveInterpolator.h ../Synth/XFadeManager.h ../Synth/BodyDisposal.h)
file (GLOB yoshimi_musicio_files
    ../MusicIO/MusicIO.cpp ../MusicIO/MusicIO.h)
file (GLOB yoshimi_manifest_ttl
    manifest.ttl)
file (GLOB yoshimi_plugin_ttl
    yoshimi.ttl)

set (FltkUI_names
    "PresetsUI"  "EnvelopeUI"
    "LFOUI"  "FilterUI"  "VirKeyboardUI"
    "ConfigUI"  "SUBnoteUI"  "ResonanceUI"
    "OscilGenUI"  "ADnoteUI"  "PADnoteUI"
    "EffUI"  "BankUI"  "PartUI"
    "MicrotonalUI"  "MasterUI" "MasterMiscUI"
    "ParametersUI" "ConsoleUI" "VectorUI"
    "MidiLearnUI"
)

# workaround fltk_wrap_ui breakage
set (FltkUI_sources)
set (FltkUI_headers)
foreach(basename ${FltkUI_names})
    set (fluidfile "${CMAKE_CURRENT_SOURCE_DIR}/../UI/${basename}.fl")
    set (sourcefile "${basename}.cpp")
    set (headerfile "${basename}.h")
    add_custom_command(
        OUTPUT ${sourcefile}
        COMMAND ${FLTK_FLUID_EXECUTABLE} ARGS -c -o .cpp ${fluidfile}
        DEPENDS ${fluidfile}
    )
    set (FltkUI_sources ${FltkUI_sources} "${sourcefile}")
    set (FltkUI_headers ${FltkUI_headers} "${headerfile}")
endforeach(basename ${FltkUI_names})

set (FltkUI_sources
    ${FltkUI_sources}
    ../UI/DynamicTooltip.cpp
    ../UI/WidgetPDial.cpp
    ../UI/WidgetMWSlider.cpp
    ../UI/WidgetCheckButton.cpp
    ../UI/WidgetSpinner.cpp
    ../UI/YoshiWin.cpp
)

add_definitions (-DYOSHIMI_LV2_PLUGIN=1)
add_definitions (-fvisibility=hidden)

add_library (yoshimi_lv2 MODULE
            ${yoshimi_lv2_plugin_files}
            ${yoshimi_manifest_ttl}
            ${yoshimi_plugin_ttl}
            ${yoshimi_dsp_files}
            ${yoshimi_effects_files}
            ${yoshimi_misc_files}
            ${yoshimi_interface_files}
            ${yoshimi_params_files}
            ${yoshimi_synth_files}
            ${yoshimi_musicio_files}
            ${FltkUI_sources})

add_custom_target(yoshimi_lv2_ttl
                   COMMAND test -f ${yoshimi_manifest_ttl}
                   COMMAND test -f ${yoshimi_plugin_ttl})

SET_TARGET_PROPERTIES(yoshimi_lv2 PROPERTIES PREFIX "")
include_directories (AFTER
                            ${LV2_INCLUDE_DIRS}
                            ${FLTK_INCLUDE_DIR}
                            ${MXML_INCLUDE_DIRS}
                            ${FONTCONFIG_INCLUDE_DIRS}
                            ${FFTW3F_INC_DIR}
                            ${CMAKE_CURRENT_SOURCE_DIR}
                            ${CMAKE_SOURCE_DIR})

target_link_libraries(yoshimi_lv2
                      ${LV2_LIBRARIES}
                      ${FLTK_LIBRARIES}
                      ${MXML_LIBRARIES}
                      ${LIBSNDFILE_LIBRARIES}
                      ${FFTW3F_LIBRARIES}
                      ${LIBCAIRO_LIBRARIES}
                      z
                      ${LIBDL_LINUX_LIBS}
)

add_dependencies(yoshimi_lv2 yoshimi_lv2_ttl)

install (TARGETS yoshimi_lv2 DESTINATION ${LV2_INSTALL_DIR}/yoshimi.lv2)
install (FILES ${yoshimi_manifest_ttl} ${yoshimi_plugin_ttl}
  DESTINATION ${LV2_INSTALL_DIR}/yoshimi.lv2
)

set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${FltkUI_headers}")

=== debian/changelog ===
yoshimi (2.2.0-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 05 Aug 2022 14:48:23 -0700

yoshimi (2.2.0-2) unstable; urgency=medium

  * Fix ftbfs on riscv64 (Closes: #1011451)

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 25 May 2022 21:47:31 +0200

yoshimi (2.2.0-1) unstable; urgency=medium

  * New upstream version 2.2.0
  * Remove dfsg tag, splashreference.svg has been removed by upstream
  * Bump Standards Version to 4.6.1
  * Bump d/copyright years
  * Refresh patchset
  * Refresh lintian-overrides

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 19 May 2022 18:40:03 +0200

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dennis Braun <d_braun@kabelmail.de>,
           Jaromír Mikeš <mira.mikes@seznam.cz>,
           IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dssi-dev,
               fluid,
               libasound2-dev,
               libcairo2-dev,
               libfftw3-dev,
               libfltk1.3-dev,
               libfontconfig1-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libjack-jackd2-dev | libjack-dev,
               libmxml-dev,
               libncurses5-dev,
               libreadline-dev,
               libx11-dev,
               libxext-dev,
               lv2-dev,
               pkg-config,
               sharutils,
               zlib1g-dev
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
Homepage: https://yoshimi.sourceforge.io

Package: yoshimi
Architecture: any
Depends: yoshimi-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: jackd, yoshimi-doc
Description: software synthesizer originally based on ZynAddSubFX2
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.

Package: yoshimi-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: yoshimi
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: yoshimi
Description: Documentation for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides documentation for Yoshimi.

## yoshimi 2.2.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,13 @@
 
 add_definitions(-Wall)
 
+# avoid exporting any (spurious) symbols in EXE and Plugin
+# Note: the two LV2 descriptors are already marked visibility=default in LV2 headers
+cmake_policy (SET CMP0063 NEW)
+set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
+
+
 # vvv
 #add_definitions(-Wpedantic) # full ISO spec
 #add_definitions(-Werror) # warnings as errors
@@ -45,7 +52,7 @@
 #add_definitions(-Wno-deprecated)
 # ^^^ comment these out on release pushes
 
-set (YOSHIMI_VERSION "2.2.0")
+set (YOSHIMI_VERSION "2.2.1")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
 add_definitions (-DMIN_CONFIG_MINOR=0)
@@ -143,6 +150,7 @@
 
 find_package (PkgConfig REQUIRED)
 
+set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads REQUIRED)
 
 check_c_source_compiles (
@@ -415,16 +423,3 @@
     ${FltkUI_sources}
 )
 
-include_directories (AFTER
-    ${MXML_INCLUDE_DIRS}
-    ${ALSA_INCLUDE_DIRS}
-    ${JACK_INCLUDE_DIRS}
-    ${FONTCONFIG_INCLUDE_DIRS}
-    ${FLTK_INCLUDE_DIR}
-    ${FFTW3F_INCLUDE_DIRS}
-    ${LIBCAIRO_INCLUDE_DIRS}
-    ${Readline_INCLUDE_DIR}
-    ${ZLIB_INCLUDE_DIRS}
-)
-
-set(ExternLibraries

=== src/LV2_Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -115,7 +115,6 @@
 )
 
 add_definitions (-DYOSHIMI_LV2_PLUGIN=1)
-add_definitions (-fvisibility=hidden)
 
 add_library (yoshimi_lv2 MODULE
             ${yoshimi_lv2_plugin_files}

=== debian/changelog ===
yoshimi (2.2.1-1) unstable; urgency=medium

  * New upstream version 2.2.1
  * Drop patches applied by upstream
  * Update lintian-overrides

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 01 Aug 2022 22:50:32 +0200

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <d_braun@kabelmail.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dssi-dev,
 fluid,
 libasound2-dev,
 libcairo2-dev,
 libfftw3-dev,
 libfltk1.3-dev,
 libfontconfig1-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjack-jackd2-dev | libjack-dev,
 libmxml-dev,
 libncurses5-dev,
 libreadline-dev,
 libx11-dev,
 libxext-dev,
 lv2-dev,
 pkg-config,
 sharutils,
 zlib1g-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
Homepage: https://yoshimi.sourceforge.io

Package: yoshimi
Architecture: any
Depends:
 yoshimi-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 jackd,
 yoshimi-doc,
Description: software synthesizer originally based on ZynAddSubFX2
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.

Package: yoshimi-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 yoshimi,
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 yoshimi,
Description: Documentation for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides documentation for Yoshimi.

## yoshimi 2.2.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -49,10 +49,9 @@
 #add_definitions(-Werror=format-security)
 #add_definitions(-Wextra)
 #add_definitions(-Wno-vla) # Nothing wrong with variable length arrays
-#add_definitions(-Wno-deprecated)
 # ^^^ comment these out on release pushes
 
-set (YOSHIMI_VERSION "2.2.1")
+set (YOSHIMI_VERSION "2.2.3")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
 add_definitions (-DMIN_CONFIG_MINOR=0)
@@ -423,3 +422,4 @@
     ${FltkUI_sources}
 )
 
+include_directories (AFTER

=== src/LV2_Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -57,13 +57,13 @@
     ../Params/ADnoteParameters.cpp  ../Params/EnvelopeParams.cpp
     ../Params/FilterParams.cpp  ../Params/LFOParams.cpp
     ../Params/SUBnoteParameters.cpp  ../Params/PADnoteParameters.cpp
-    ../Params/Controller.cpp  ../Params/Presets.cpp ../Params/PresetsStore.cpp
+    ../Params/Controller.cpp  ../Params/Presets.cpp ../Params/PresetsStore.cpp  ../Params/UnifiedPresets.cpp
     ../Params/ADnoteParameters.h  ../Params/EnvelopeParams.h
     ../Params/FilterParams.h  ../Params/LFOParams.h
     ../Params/SUBnoteParameters.h
     ../Params/PADnoteParameters.h ../Params/PADStatus.h ../Params/RandomWalk.h
     ../Params/OscilParameters.cpp ../Params/OscilParameters.h
-    ../Params/Controller.h  ../Params/Presets.h ../Params/PresetsStore.h)
+    ../Params/Controller.h  ../Params/Presets.h ../Params/PresetsStore.h ../Params/UnifiedPresets.h)
 file (GLOB yoshimi_synth_files
     ../Synth/ADnote.cpp  ../Synth/Envelope.cpp  ../Synth/LFO.cpp  ../Synth/OscilGen.cpp
     ../Synth/SUBnote.cpp  ../Synth/Resonance.cpp  ../Synth/PADnote.cpp

=== debian/changelog ===
yoshimi (2.2.3-1) unstable; urgency=medium

  * New upstream version 2.2.3
  * Change my email address
  * Replace obsolete B-Ds
  * Bump Standards-Version to 4.6.2
  * Bump d/copyright years
  * Refresh lintian-overrides

 -- Dennis Braun <snd@debian.org>  Fri, 24 Feb 2023 22:02:23 +0100

yoshimi (2.2.2.1-1) unstable; urgency=medium

  * New upstream version 2.2.2.1
    (Closes: #1019471)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 12 Sep 2022 23:39:18 +0200

yoshimi (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 06 Sep 2022 22:10:41 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
- Dennis Braun <d_braun@kabelmail.de>,
+ Dennis Braun <snd@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
@@ -15,12 +15,12 @@
  libcairo2-dev,
  libfftw3-dev,
  libfltk1.3-dev,
- libfontconfig1-dev,
- libgl1-mesa-dev | libgl-dev,
+ libfontconfig-dev,
+ libgl-dev,
  libglu1-mesa-dev | libglu-dev,
  libjack-jackd2-dev | libjack-dev,
  libmxml-dev,
- libncurses5-dev,
+ libncurses-dev,
  libreadline-dev,
  libx11-dev,
  libxext-dev,
@@ -28,7 +28,7 @@
  pkg-config,
  sharutils,
  zlib1g-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/yoshimi-$1\.tar\.gz/ \
https://github.com/Yoshimi/yoshimi/tags .*/v?(\d[\d\.]+)\.tar\.gz

## yoshimi 2.3.0.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #   CMakeLists.txt
 #
 #   Copyright 2009-2011, Alan Calvert
-#   Copyright 2014-2021, Will Godfrey & others
+#   Copyright 2014-2023, Will Godfrey & others
 #
 #   This file is part of yoshimi, which is free software: you can
 #   redistribute it and/or modify it under the terms of the GNU General
@@ -51,10 +51,10 @@
 #add_definitions(-Wno-vla) # Nothing wrong with variable length arrays
 # ^^^ comment these out on release pushes
 
-set (YOSHIMI_VERSION "2.2.3")
+set (YOSHIMI_VERSION "2.3.0.3")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
-add_definitions (-DMIN_CONFIG_MINOR=0)
+add_definitions (-DMIN_CONFIG_MINOR=3)
 
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
@@ -135,7 +135,7 @@
 
 set (BuildOptionsBasic
     "-ffast-math -fomit-frame-pointer"
-    CACHE STRING "basic compilier options"
+    CACHE STRING "basic compiler options"
 )
 
 set (BuildOptionsDebug

=== src/LV2_Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -96,9 +96,9 @@
     set (sourcefile "${basename}.cpp")
     set (headerfile "${basename}.h")
     add_custom_command(
-        OUTPUT ${sourcefile}
-        COMMAND ${FLTK_FLUID_EXECUTABLE} ARGS -c -o .cpp ${fluidfile}
-        DEPENDS ${fluidfile}
+      OUTPUT ${sourcefile}
+      COMMAND ${FLTK_FLUID_EXECUTABLE} ARGS -c -o .cpp ${fluidfile}
+      DEPENDS ${fluidfile}
     )
     set (FltkUI_sources ${FltkUI_sources} "${sourcefile}")
     set (FltkUI_headers ${FltkUI_headers} "${headerfile}")

=== debian/changelog ===
yoshimi (2.3.0.3-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 14 Aug 2023 19:40:56 -0700

yoshimi (2.3.0.3-1) unstable; urgency=medium

  * New upstream version 2.3.0.3
  * d/copyright: Remove obsolete Files-Excluded

 -- Dennis Braun <snd@debian.org>  Sun, 06 Aug 2023 22:00:02 +0200

yoshimi (2.3.0.2-1) unstable; urgency=medium

  * New upstream version 2.3.0.2
    + Drop patches applied upstream
  * Update d/copyright
    + Drop repack-suffix again (upstream fixed license issues)
    + Update copyright exclude patterns
    + Update d/copyright_hints
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 19 Jun 2023 09:38:02 +0200

yoshimi (2.3.0+dfsg-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 2.3.0
  * Refresh patchset, add spelling error patch
  * Prefer libjack-dev over libjack-jackd2-dev

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Exclude non-free files (and add '+dfsg' to the version)
  * Update d/copyright
    * Add some more copyright info and licenses
    * Add 'licensecheck' target (ignoring some binary files)
    * Generate d/copyright_hints
  * Add versionmangling to d/watch

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 13 Jun 2023 15:21:14 +0200

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dennis Braun <snd@debian.org>,
           Jaromír Mikeš <mira.mikes@seznam.cz>,
           IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dssi-dev,
               fluid,
               libasound2-dev,
               libcairo2-dev,
               libfftw3-dev,
               libfltk1.3-dev,
               libfontconfig-dev,
               libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libjack-dev | libjack-jackd2-dev,
               libmxml-dev,
               libncurses-dev,
               libreadline-dev,
               libx11-dev,
               libxext-dev,
               lv2-dev,
               pkg-config,
               sharutils,
               zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
Homepage: https://yoshimi.sourceforge.io

Package: yoshimi
Architecture: any
Depends: yoshimi-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: jackd, yoshimi-doc
Description: software synthesizer originally based on ZynAddSubFX2
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.

Package: yoshimi-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: yoshimi
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: yoshimi
Description: Documentation for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides documentation for Yoshimi.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export LV2_PATH = /usr/lib/lv2

%:
	dh $@ --sourcedirectory=src

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|doc/yoshimi_user_guide/(.*/)*images/.*\.png|doc/examples/Original Zyn Patchsets/.*|doc/examples/.*\.x..|doc/examples/Out_There\.mid|banks/.*\.xiz|dev_notes/Yoshimi Control Numbers\.ods|doc/The Short Yoshimi Guide\.odt|doc/Histories/Yoshimi CCs and NRPNs\.pdf

# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## yoshimi 2.3.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -49,9 +49,10 @@
 #add_definitions(-Werror=format-security)
 #add_definitions(-Wextra)
 #add_definitions(-Wno-vla) # Nothing wrong with variable length arrays
+#add_definitions(-Wno-unqualified-std-cast-call) # supresses clang warning 'unqualified call'
 # ^^^ comment these out on release pushes
 
-set (YOSHIMI_VERSION "2.3.0.3")
+set (YOSHIMI_VERSION "2.3.1")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
 add_definitions (-DMIN_CONFIG_MINOR=3)
@@ -417,9 +418,3 @@
     ${Params_sources}
     ${Synth_sources}
     ${DSP_sources}
-    ${Effects_sources}
-    ${MusicIO_sources}
-    ${FltkUI_sources}
-)
-
-include_directories (AFTER

=== debian/changelog ===
yoshimi (2.3.1-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 28 Oct 2023 15:12:09 -0700

yoshimi (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Update copyright information
    + Re-generate d/copyright_hints (with another MIDI file excluded)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 16 Oct 2023 21:25:03 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export LV2_PATH = /usr/lib/lv2

%:
	dh $@ --sourcedirectory=src


# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|doc/yoshimi_user_guide/(.*/)*images/.*\.png|doc/examples/Original Zyn Patchsets/.*|doc/examples/.*\.x..|doc/examples/(Out_There|Arram_Koth_Finale)\.mid|banks/.*\.xiz|dev_notes/Yoshimi Control Numbers\.ods|doc/The Short Yoshimi Guide\.odt|doc/Histories/Yoshimi CCs and NRPNs\.pdf

# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## yoshimi 2.3.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 #
 #   Copyright 2009-2011, Alan Calvert
 #   Copyright 2014-2023, Will Godfrey & others
+#   Copyright 2024, Kristian Amlie, Will Godfrey
 #
 #   This file is part of yoshimi, which is free software: you can
 #   redistribute it and/or modify it under the terms of the GNU General
@@ -30,8 +31,8 @@
 
 #set(CMAKE_CXX_COMPILER "clang++")
 
-set (CMAKE_CXX_STANDARD 14) # we seem to need both for
-add_definitions(-std=gnu++14) # various versions of cmake
+set (CMAKE_CXX_STANDARD 17) # we seem to need both for
+add_definitions(-std=gnu++17) # various versions of cmake
 
 add_definitions(-Wall)
 
@@ -52,7 +53,7 @@
 #add_definitions(-Wno-unqualified-std-cast-call) # supresses clang warning 'unqualified call'
 # ^^^ comment these out on release pushes
 
-set (YOSHIMI_VERSION "2.3.1")
+set (YOSHIMI_VERSION "2.3.2")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
 add_definitions (-DMIN_CONFIG_MINOR=3)
@@ -106,7 +107,7 @@
 
 # developer info
 option (ShowNoteOnTimes "Report Note-On Times" OFF)
-option (ReportNotes "Report Notes On/Off" OFF)
+option (ReportNoteEvents "Report Notes On/Off" OFF)
 
 
 set (BuildOptions_X86
@@ -304,6 +305,7 @@
     Interface/MidiDecode.cpp
     Interface/RingBuffer.h
     Interface/TextLists.h
+    Interface/TextLists.cpp
 )
 
 set (CLI_Sources
@@ -316,8 +318,8 @@
     Params/ADnoteParameters.cpp  Params/EnvelopeParams.cpp
     Params/FilterParams.cpp  Params/LFOParams.cpp
     Params/SUBnoteParameters.cpp  Params/PADnoteParameters.cpp
-    Params/Controller.cpp  Params/Presets.cpp
-    Params/PresetsStore.cpp  Params/UnifiedPresets.cpp
+    Params/Controller.cpp  Params/ParamCheck.cpp
+    Params/UnifiedPresets.cpp
     Params/OscilParameters.cpp
 )
 
@@ -384,7 +386,7 @@
     add_definitions (-DREPORT_NOTEON)
 endif ()
 
-if (ReportNotes)
+if (ReportNoteEvents)
     add_definitions (-DREPORT_NOTES_ON_OFF)
 endif ()
 
@@ -415,6 +417,3 @@
     ${Interface_Sources}
     ${CLI_Sources}
     ${Misc_sources}
-    ${Params_sources}
-    ${Synth_sources}
-    ${DSP_sources}

=== src/LV2_Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,8 @@
 #   CMakeLists.txt (LV2)
 #
 #   Copyright 2014, Andrew Deryabin <andrewderyabin@gmail.com>
-#   Copyright 2018-2021, Will Godfrey & others
+#   Copyright 2018-2023, Will Godfrey & others
+#   Copyright 2024 Kristian Amlie
 #
 #   This file is part of yoshimi, which is free software: you can
 #   redistribute it and/or modify it under the terms of the GNU General
@@ -50,6 +51,7 @@
     ../Interface/InterChange.cpp ../Interface/InterChange.h
     ../Interface/Data2Text.cpp ../Interface/Data2text.h
     ../Interface/Text2Data.cpp ../Interface/Text2Data.h
+    ../Interface/TextLists.cpp ../Interface/TextLists.h
     ../Interface/RingBuffer.h
     ../Interface/MidiLearn.cpp ../Interface/MidiLearn.h
     ../UI/MiscGui.cpp ../UI/MiscGui.h)
@@ -57,13 +59,13 @@
     ../Params/ADnoteParameters.cpp  ../Params/EnvelopeParams.cpp
     ../Params/FilterParams.cpp  ../Params/LFOParams.cpp
     ../Params/SUBnoteParameters.cpp  ../Params/PADnoteParameters.cpp
-    ../Params/Controller.cpp  ../Params/Presets.cpp ../Params/PresetsStore.cpp  ../Params/UnifiedPresets.cpp
+    ../Params/Controller.cpp  ../Params/ParamCheck.cpp  ../Params/UnifiedPresets.cpp
     ../Params/ADnoteParameters.h  ../Params/EnvelopeParams.h
     ../Params/FilterParams.h  ../Params/LFOParams.h
     ../Params/SUBnoteParameters.h
     ../Params/PADnoteParameters.h ../Params/PADStatus.h ../Params/RandomWalk.h
     ../Params/OscilParameters.cpp ../Params/OscilParameters.h
-    ../Params/Controller.h  ../Params/Presets.h ../Params/PresetsStore.h ../Params/UnifiedPresets.h)
+    ../Params/Controller.h  ../Params/ParamCheck.h ../Params/UnifiedPresets.h)
 file (GLOB yoshimi_synth_files
     ../Synth/ADnote.cpp  ../Synth/Envelope.cpp  ../Synth/LFO.cpp  ../Synth/OscilGen.cpp
     ../Synth/SUBnote.cpp  ../Synth/Resonance.cpp  ../Synth/PADnote.cpp

=== debian/changelog ===
yoshimi (2.3.2-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:24:38 +0000

yoshimi (2.3.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:33:40 +0000

yoshimi (2.3.2-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:06:13 +0000

yoshimi (2.3.2-1) unstable; urgency=medium

  * New upstream version 2.3.2
  * Change B-D from pkg-config to pkgconf
  * Bump d/copyright years
  * Use the default salsa CI/CD configuration

 -- Dennis Braun <snd@debian.org>  Fri, 23 Feb 2024 20:15:11 +0100

yoshimi (2.3.1.3-1) unstable; urgency=medium

  * New upstream version 2.3.1.3
  * d/control: Update homepage to github (Closes: #1054134)

 -- Dennis Braun <snd@debian.org>  Mon, 11 Dec 2023 20:32:19 +0100

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <snd@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dssi-dev,
 fluid,
 libasound2-dev,
 libcairo2-dev,
 libfftw3-dev,
 libfltk1.3-dev,
 libfontconfig-dev,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjack-dev | libjack-jackd2-dev,
 libmxml-dev,
 libncurses-dev,
 libreadline-dev,
 libx11-dev,
 libxext-dev,
 lv2-dev,
 pkgconf,
 sharutils,
 zlib1g-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
Homepage: https://yoshimi.github.io

Package: yoshimi
Architecture: any
Depends:
 yoshimi-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 jackd,
 yoshimi-doc,
Description: software synthesizer originally based on ZynAddSubFX2
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.

Package: yoshimi-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 yoshimi,
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 yoshimi,
Description: Documentation for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides documentation for Yoshimi.

=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,6 @@
 
 %:
 	dh $@ --sourcedirectory=src
-
-
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
         debian/.*|doc/yoshimi_user_guide/(.*/)*images/.*\.png|doc/examples/Original Zyn Patchsets/.*|doc/examples/.*\.x..|doc/examples/(Out_There|Arram_Koth_Finale)\.mid|banks/.*\.xiz|dev_notes/Yoshimi Control Numbers\.ods|doc/The Short Yoshimi Guide\.odt|doc/Histories/Yoshimi CCs and NRPNs\.pdf

=== debian/tests/control ===
Test-Command: xvfb-run -a debian/tests/run-yoshimi simple.yosh
Depends:
 xauth,
 xvfb,
 yoshimi,
Restrictions: allow-stderr, superficial

Test-Command: xvfb-run -a debian/tests/run-yoshimi play.yosh
Depends:
 xauth,
 xvfb,
 yoshimi,
Restrictions: allow-stderr
